/* VError.h */

/*
remap
Copyright (C) 2006 Fabrice Ducos, fabrice.ducos@icare.univ-lille1.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef VError_H
#define VError_H

#include <string>
#include <exception>

#include "debug.h"

class VError : public std::exception {

 public:
  VError(const std::string& message) : message_(message) { PDEBUG; }
  VError(const char *message) : message_(message) { PDEBUG; }
  ~VError() throw() { PDEBUG; }
  virtual const char *what() const throw() { PDEBUG; return message_.c_str(); }

 private:
  std::string message_;

};

#endif
