/* VHdf.h */

/*
remap
Copyright (C) 2006 Fabrice Ducos, fabrice.ducos@icare.univ-lille1.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef VHdf_H
#define VHdf_H

#include <cstring>
#include "VFile.h"
#include "hdfcpp.hpp"

class VHdf : public VFile {

 public:
  VHdf(const char *filename, const char *dataset, int ichannel = 0, const char *sds_time = NULL, const char *sds_latitude = "Latitude", const char *sds_longitude = "Longitude");
  int ichannel() { return ichannel_; }
  virtual void get_calibration(double &slope, double &offset) const;
  virtual ~VHdf();

 protected:
  virtual void read_data_2D(const char *dataset);
  virtual void read_data_3D(const char *dataset, int ichannel);
  virtual void read_lat_lon_time();
  virtual void destroy();

};

#endif
