/* VIIR.h */

/*
remap
Copyright (C) 2006 Fabrice Ducos, fabrice.ducos@icare.univ-lille1.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef VIIR_H
#define VIIR_H

#include "VHdf.h"

class VIIR : public VHdf {

 public:
  VIIR(const char *filename, const char *dataset, int ichannel = 0);
  void get_calibration(double &slope, double &offset) const;
  typedef enum { IIR_CHANNEL_8_65, IIR_CHANNEL_10_6, IIR_CHANNEL_12_05 } iir_channels;

 protected:
  void read_lat_lon_time();

 private:
  static const double wavelengths[];
  
};

#endif
