/* VModis.h */

/*
remap
Copyright (C) 2006 Fabrice Ducos, fabrice.ducos@icare.univ-lille1.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef VModis_H
#define VModis_H

#include <cstring>
#include "VHdf.h"

class VModis : public VHdf {

 public:
  VModis(const char *filename, const char *dataset, int ichannel = 0);
  int ichannel() { return ichannel_; }

  void get_calibration(double &slope, double &offset) const;
  ~VModis();

 protected:
  void read_lat_lon_time();

 private:
  void interpol(int sample_nrows, int sample_ncols, const coord_type *sample_lat, const coord_type *sample_lon,
		int full_nrows, int full_ncols, coord_type *full_lat, coord_type *full_lon);
  double ichannel_to_wavelength(int ichannel) const;
  static const double wavelengths[];

};

#endif
