/* VXRIT_SEVIRI.h */

/*
remap
Copyright (C) 2006 Fabrice Ducos, fabrice.ducos@icare.univ-lille1.fr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef VXRIT_SEVIRI_H
#define VXRIT_SEVIRI_H

#include <vector>
#include <stdint.h>
#include "VFile.h"
#include "libxrit.h"

class VXRIT_SEVIRI : public VFile {
 public:
  VXRIT_SEVIRI(const char *filename, const char *dataset);
  void get_calibration(double &slope, double &offset) const;
  ~VXRIT_SEVIRI();

 private:
  static const int SEVIRI_NROWS = 3712;
  static const int SEVIRI_NCOLS = 3712;

  MSG_Prologue prologue_;
  void read_seviri_latlon(const char *filename, size_t nbuffer, float *buffer);
  void allocate(size_t n);
  void destroy();

  static const double wavelengths[];

};

#endif
